std::unique_ptr< _Tp[], _Dp > Class Template Reference
Utilities » Memory » Pointer Abstractions

## Public Types

template<typename _Up >
using | __safe_conversion_raw = __and_< __or_< __or_< is_same< _Up, pointer >, is_same< _Up, nullptr_t > >, __and_< is_pointer< _Up >, is_same< pointer, element_type * >, is_convertible< typename remove_pointer< _Up >::type(*)[], element_type(*)[]> > > >
template<typename _Up , typename _Ep , typename _Up_up = unique_ptr<_Up, _Ep>, typename _Up_element_type = typename _Up_up::element_type>
using | __safe_conversion_up = __and_< is_array< _Up >, is_same< pointer, element_type * >, is_same< typename _Up_up::pointer, _Up_element_type * >, is_convertible< _Up_element_type(*)[], element_type(*)[]>, __or_< __and_< is_reference< deleter_type >, is_same< deleter_type, _Ep > >, __and_< __not_< is_reference< deleter_type > >, is_convertible< _Ep, deleter_type > >> >
typedef _Dp | deleter_type
typedef _Tp | element_type
typedef _Pointer::type | pointer

## Public Member Functions

constexpr | unique_ptr () noexcept
template<typename _Up , typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>
| unique_ptr (_Up __p) noexcept
template<typename _Up , typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>
| unique_ptr (_Up __p, typename conditional< is_reference< deleter_type >::value, deleter_type, const deleter_type &>::type __d) noexcept
template<typename _Up , typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>
| unique_ptr (_Up __p, typename remove_reference< deleter_type >::type &&__d) noexcept
| unique_ptr (unique_ptr &&__u) noexcept
constexpr | unique_ptr (nullptr_t) noexcept
template<typename _Up , typename _Ep , typename = _Require<__safe_conversion_up<_Up, _Ep>>>
| unique_ptr (unique_ptr< _Up, _Ep > &&__u) noexcept
| unique_ptr (const unique_ptr &)=delete
| ~unique_ptr ()
pointer | get () const noexcept
deleter_type & | get_deleter () noexcept
const deleter_type & | get_deleter () const noexcept
| operator bool () const noexcept
unique_ptr & | operator= (unique_ptr &&__u) noexcept
template<typename _Up , typename _Ep >
enable_if< __and_< __safe_conversion_up< _Up, _Ep >, is_assignable< deleter_type &, _Ep && > >::value, unique_ptr & >::type | operator= (unique_ptr< _Up, _Ep > &&__u) noexcept
unique_ptr & | operator= (nullptr_t) noexcept
unique_ptr & | operator= (const unique_ptr &)=delete
std::add_lvalue_reference< element_type >::type | operator[] (size_t __i) const
pointer | release () noexcept
template<typename _Up , typename = _Require< __or_<is_same<_Up, pointer>, __and_<is_same<pointer, element_type*>, is_pointer<_Up>, is_convertible< typename remove_pointer<_Up>::type(*)[], element_type(*)[] > > > >>
void | reset (_Up __p) noexcept
void | reset (nullptr_t=nullptr) noexcept
void | swap (unique_ptr &__u) noexcept

## Detailed Description

### template<typename _Tp, typename _Dp>
class std::unique_ptr< _Tp[], _Dp >

20.7.1.3 unique_ptr for array objects with a runtime length

Definition at line 370 of file unique_ptr.h.

## Constructor & Destructor Documentation

## unique_ptr() [1/6]

template<typename _Tp , typename _Dp >

constexpr std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( |  | ) |

inline noexcept

Default constructor, creates a unique_ptr that owns nothing.

Definition at line 437 of file unique_ptr.h.

## unique_ptr() [2/6]

template<typename _Tp , typename _Dp >
template<typename _Up , typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | _Up | __p | ) |

inline explicit noexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an array of a type safely convertible to an array of `element_type`

The deleter will be value-initialized.

Definition at line 453 of file unique_ptr.h.

## unique_ptr() [3/6]

template<typename _Tp , typename _Dp >
template<typename _Up , typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | _Up | __p,
|  | typename conditional< is_reference< deleter_type >::value, deleter_type, const deleter_type &>::type | __d
| ) |  |

inline noexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an array of a type safely convertible to an array of `element_type`
  __d | A reference to a deleter.

The deleter will be initialized with `__d`

Definition at line 469 of file unique_ptr.h.

## unique_ptr() [4/6]

template<typename _Tp , typename _Dp >
template<typename _Up , typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | _Up | __p,
|  | typename remove_reference< deleter_type >::type && | __d
| ) |  |

inline noexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an array of a type safely convertible to an array of `element_type`
  __d | A reference to a deleter.

The deleter will be initialized with `std::move(__d)`

Definition at line 485 of file unique_ptr.h.

## unique_ptr() [5/6]

template<typename _Tp , typename _Dp >

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | unique_ptr< _Tp[], _Dp > && | __u | ) |

inline noexcept

Move constructor.

Definition at line 492 of file unique_ptr.h.

## unique_ptr() [6/6]

template<typename _Tp , typename _Dp >

constexpr std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | nullptr_t |  | ) |

inline noexcept

Creates a unique_ptr that owns nothing.

Definition at line 496 of file unique_ptr.h.

## ~unique_ptr()

template<typename _Tp , typename _Dp >

std::unique_ptr< _Tp[], _Dp >::~unique_ptr | ( |  | ) |

inline

Destructor, invokes the deleter if the stored pointer is not null.

Definition at line 507 of file unique_ptr.h.

References std::get_deleter().

## Member Function Documentation

## get()

template<typename _Tp , typename _Dp >

pointer std::unique_ptr< _Tp[], _Dp >::get | ( | void |  | ) | const

inline noexcept

Return the stored pointer.

Definition at line 571 of file unique_ptr.h.

## get_deleter() [1/2]

template<typename _Tp , typename _Dp >

deleter_type& std::unique_ptr< _Tp[], _Dp >::get_deleter | ( |  | ) |

inline noexcept

Return a reference to the stored deleter.

Definition at line 576 of file unique_ptr.h.

## get_deleter() [2/2]

template<typename _Tp , typename _Dp >

const deleter_type& std::unique_ptr< _Tp[], _Dp >::get_deleter | ( |  | ) | const

inline noexcept

Return a reference to the stored deleter.

Definition at line 581 of file unique_ptr.h.

## operator bool()

template<typename _Tp , typename _Dp >

std::unique_ptr< _Tp[], _Dp >::operator bool | ( |  | ) | const

inline explicit noexcept

Return `true` if the stored pointer is not null.

Definition at line 585 of file unique_ptr.h.

## operator=() [1/3]

template<typename _Tp , typename _Dp >

unique_ptr& std::unique_ptr< _Tp[], _Dp >::operator= | ( | unique_ptr< _Tp[], _Dp > && | __u | ) |

inline noexcept

Move assignment operator.

Parameters

  __u | The object to transfer ownership from.

Invokes the deleter first if this object owns a pointer.

Definition at line 524 of file unique_ptr.h.

References std::get_deleter().

## operator=() [2/3]

template<typename _Tp , typename _Dp >
template<typename _Up , typename _Ep >

enable_if<__and_<__safe_conversion_up<_Up, _Ep>, is_assignable<deleter_type&, _Ep&&> >::value, unique_ptr&>::type std::unique_ptr< _Tp[], _Dp >::operator= | ( | unique_ptr< _Up, _Ep > && | __u | ) |

inline noexcept

Assignment from another type.

Parameters

  __u | The object to transfer ownership from, which owns a convertible pointer to an array object.

Invokes the deleter first if this object owns a pointer.

Definition at line 544 of file unique_ptr.h.

References std::get_deleter().

## operator=() [3/3]

template<typename _Tp , typename _Dp >

unique_ptr& std::unique_ptr< _Tp[], _Dp >::operator= | ( | nullptr_t |  | ) |

inline noexcept

Reset the unique_ptr to empty, invoking the deleter if necessary.

Definition at line 553 of file unique_ptr.h.

## operator[]()

template<typename _Tp , typename _Dp >

std::add_lvalue_reference<element_type>::type std::unique_ptr< _Tp[], _Dp >::operator[] | ( | size_t | __i | ) | const

inline

Access an element of owned array.

Definition at line 563 of file unique_ptr.h.

## release()

template<typename _Tp , typename _Dp >

pointer std::unique_ptr< _Tp[], _Dp >::release | ( |  | ) |

inline noexcept

Release ownership of any stored pointer.

Definition at line 592 of file unique_ptr.h.

## reset()

template<typename _Tp , typename _Dp >
template<typename _Up , typename = _Require< __or_<is_same<_Up, pointer>, __and_<is_same<pointer, element_type*>, is_pointer<_Up>, is_convertible< typename remove_pointer<_Up>::type(*)[], element_type(*)[] > > > >>

void std::unique_ptr< _Tp[], _Dp >::reset | ( | _Up | __p | ) |

inline noexcept

Replace the stored pointer.

Parameters

  __p | The new pointer to store.

The deleter will be invoked if a pointer is already owned.

Definition at line 618 of file unique_ptr.h.

References std::get_deleter().

## swap()

template<typename _Tp , typename _Dp >

void std::unique_ptr< _Tp[], _Dp >::swap | ( | unique_ptr< _Tp[], _Dp > & | __u | ) |

inline noexcept

Exchange the pointer and deleter with another object.

Definition at line 634 of file unique_ptr.h.

References std::unique_ptr< _Tp, _Dp >::get(), and std::unique_ptr< _Tp, _Dp >::swap().

The documentation for this class was generated from the following file:

- unique_ptr.h